function [salida acc]=main(data,in_y0,in_be,burn,reps,thin)

nvar=size(data,2); 
ilevs=nanmean(data); 
sbet=std(ilevs,1)^2;
%______________________________________________________________________________________
%Init output
efsi=(reps-burn)/thin;
salida.al=NaN(efsi,nvar);            %acc.al=0;
salida.be=NaN(efsi,nvar);      % acc.be=0;
salida.ga=NaN(efsi,1);           % acc.ga=0;
salida.la=NaN(efsi,1);       
salida.df=NaN(efsi,1);           % acc.df=0;
salida.aal=NaN(efsi,1);          % acc.aal=0;
salida.bal=NaN(efsi,1);          % acc.bal=0;
salida.hb=NaN(efsi,1);
salida.ht=NaN(efsi,1);
salida.y0=NaN(efsi,nvar);
if size(in_be)==0
    in_be=zeros(1,nvar);
end
if size(in_y0)==0
    in_y0=nanmean(data);
end
%______________________________________________________________________________________
%Init chains
al=2*rand(1,nvar)-1;   aca=zeros(1,nvar);
be=in_be;              acb=0;
ga=1;                  acg=0;
la=50;                   
df=3;                  acn=0;
aal=35;                acaa=0;
bal=35;                acba=0;
hbe=0.1;
hta=21;
y0=in_y0;              acy0=0;
%______________________________________________________________________________________
%______________________________________________________________________________________
%Proposal's parameters tot
tb=0.05e6;
ppaa=7*ones(1,nvar);
ppag=750;
ppan=4;
ppaal=159;
ppbal=159;
ppy0=0.35e3;
%______________________________________________________________________________________
%______________________________________________________________________________________
%Hyperparameters
arr=2; qaq=0.1;
%______________________________________________________________________________________
nin=0;
tic
for i=1:reps
    [y0 acy0]=ny0(data,y0,al,be,ga,la,df,ppy0,acy0);
    ome=mix(data,y0,al,be,ga,la,df);
    la=nlam(data,y0,al,be,ga,la,df,ome,hbe);
    [be acb]=nbe(data,y0,al,be,ga,la,df,ome,hbe,hta,tb,acb);
    [al aca]=nal(data,y0,al,be,ga,la,df,ome,aal,bal,hbe,ppaa,aca,2);
    [ga acg]=nga(data,y0,al,be,ga,la,df,ome,ppag,acg);
%     ga=1;
    [df acn]=nnu(data,df,ome,ppan,acn);
    [aal acaa]=naal(al,aal,bal,arr,qaq,ppaal,acaa);
    [bal acba]=nbal(al,aal,bal,arr,qaq,ppbal,acba);
    [hbe hta]=newhyp(y0,al,be,la,hbe,hta,sbet);
    
    if i<=burn && mod(i,burn/4)==0
        disp([num2str(i/burn*100) '% of burn-in'])
    end
    
    if i>burn && mod((i-burn),thin)==0
        nin=nin+1;
        una=size(al,1);
        salida.al(nin,:)=al(una,:);
        salida.ga(nin)=ga(length(ga));
        salida.la(nin)=la(length(la));
        salida.df(nin)=df(length(df));
        uaa=size(aal,1); uab=size(bal,1);
        salida.aal(nin,:)=aal(uaa,:);
        salida.bal(nin,:)=bal(uab,:);
        unb=size(be,1);
        salida.be(nin,:)=be(unb,:);
        salida.hb(nin)=hbe(length(hbe));
        salida.ht(nin)=hta(length(hta));
        uyy=size(y0,1);
        salida.y0(nin,:)=y0(uyy,:);
    end
     
    if i==burn
        disp('Burn-in pahse completed')
    end   
  
    if i>burn && mod((i-burn),(reps-burn)/10)==0
        disp([num2str((i-burn)/(reps-burn)*100) '% done'])
    end
end
toc
salida.sbet=sbet;

acc.al=aca/reps;
acc.ga=acg/reps;
acc.df=acn/reps;
acc.aal=acaa/reps;
acc.bal=acba/reps;
acc.be=acb/reps;
acc.y0=acy0/reps;
disp('ACCEPTANCE RATES')
disp('  alpha    '  )
disp([min(acc.al) max(acc.al)])
disp('       ga         nu')
disp([acc.ga acc.df])
disp('Hypers for alpha')
disp([acc.aal acc.bal])
disp('   Betas   init vals')
disp([acc.be acc.y0])