function [om]=mix(data,y0,al,be,ga,la,df)

%One draw of the mixing parameters

dimd=size(data); tt=dimd(1); nvar=dimd(2);
tim=sum(1-isnan(data)); nobs=sum(tim);
runb=size(be,1); cb=be(runb,:); 
runa=size(al,1); ca=al(runa,:);
cl=la(length(la)); cg=ga(length(ga)); cn=df(length(df));
runy=size(y0,1); cy0=y0(runy,:);

om=NaN(dimd);
aa=(cn+1)/2;

if isequal(nobs,tt*nvar)
    dat0=[cy0;data(1:tt-1,:)];
    cmb=ones(tt,1)*cb;
    ca=ones(tt,1)*ca;
    ker=data - ca.*dat0 - cmb.*(1-ca);
    scl=(ker<=0)*cg+(ker>0)/cg;
    bb=0.5*(cn+cl*(ker.*scl).^2);
    om=gamrnd(aa,1./bb);
else
    for i=1:nvar
        whos=find(~isnan(data(:,i)));
        loni=tim(i);
        dati=data(whos,i);
        dat0=[cy0(i);dati(1:loni-1)];
        ker=dati-ca(i)*dat0-cb(i)*(1-ca(i));
        scl=(ker<=0)*cg+(ker>0)/cg;
        bb=0.5*(cn+cl*(ker.*scl).^2);
        om(whos,i)=gamrnd(aa,1./bb);
    end
end